/**
 * @module dixim
 * @submodule vdms
 */
dixim.namespace('dixim.vdms');

/**
 * @module vdms
 * @submodule progress-dialog-view
 */

(function() {
var ProgressDialogView;
var prototype;
var superConstructor;
var _ = dixim.ctt.ResourceBundle.get;
var ProgressModalDialogView = dixim.common.ProgressModalDialogView;
var Enum = dixim.ctt.util.Enum;

/**
 * @class ProgressDialogView
 * @constructor
 * @param {Object} configs
 */
ProgressDialogView = function(configs) {
    ProgressModalDialogView.call(this, configs);
};

dixim.inherit(ProgressDialogView, ProgressModalDialogView);
dixim.vdms.ProgressDialogView = ProgressDialogView;
prototype = ProgressDialogView.prototype;
superConstructor = ProgressDialogView.superConstructor;

var Mode = Enum.fetch('PROGRESS');

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    var mode = configs.mode || Mode.CONTENTS;
    var contents = configs.contents || [];

    configs = configs || {};

    configs.id = configs.id || '';
    configs.id = [configs.id, 'progress-dialog-'].join('');

    configs.nameKey = 'friendlyName';
    switch(mode) {
        case Mode.NON_AGGREGATION:
            configs.title = _('vdms_aggregation_operation_non_aggregate');
            configs.description = _('vdms_aggregation_operation_non_aggregate_description', contents.length);
            configs.progressStr = _('vdms_aggregation_operation_non_aggregate_progress')
            break;
        case Mode.AGGREGATION:
            configs.title = _('vdms_aggregation_operation_aggregate');
            configs.description = _('vdms_aggregation_operation_aggregate_description', contents.length);
            configs.progressStr = _('vdms_aggregation_operation_aggregate_progress')
            break;
        case Mode.PAUSE:
            configs.title = _('vdms_aggregation_operation_pause');
            configs.description = _('vdms_aggregation_operation_pause_description', contents.length);
            configs.progressStr = _('vdms_aggregation_operation_pause_progress')
            break;
        case Mode.RESTART:
            configs.title = _('vdms_aggregation_operation_restart');
            configs.description = _('vdms_aggregation_operation_restart_description', contents.length);
            configs.progressStr = _('vdms_aggregation_operation_restart_progress')
            break;
    }

    superConstructor.prototype._initialize.call(this, configs);
};

}());
