/**
 * @module ctt
 * @submodule confirmation-wizard-move-item-controller
 */
(function() {
var Event = dixim.event.Event;
var WizardPageController = dixim.ctt.WizardPageController;
var ConfirmationWizardPageView = dixim.ctt.ConfirmationWizardPageView;
var ConfirmationWizardPageController = dixim.ctt.ConfirmationWizardPageController;

var ConfirmationWizardMoveItemController;
var prototype;
var superConstructor;

/**
 * @class ConfirmationWizardMoveItemController
 * @extends WizardPageController
 * @constructor
 * @param {Object} configs
 */
ConfirmationWizardMoveItemController = function(configs) {
  WizardPageController.call(this, configs);
};
dixim.inherit(ConfirmationWizardMoveItemController, WizardPageController);
dixim.ctt.ConfirmationWizardMoveItemController = ConfirmationWizardMoveItemController;
prototype = ConfirmationWizardMoveItemController.prototype;
superConstructor = ConfirmationWizardMoveItemController.superConstructor;

prototype._createView = function() {
  this._isDownloadMoveIn = this._wizard.getRegistryEntry('isDownloadMoveIn');
  this._view = new ConfirmationWizardPageView({
    isDownloadMoveIn: this._isDownloadMoveIn
  });
};

prototype.start = function() {
  var v;

  if (!!!this._view) {
    this._createView();
  }

  v = this._view;
  v.addEventListener('render', this._didRenderView, this);
  v.addEventListener('cancel', this._didCancel, this);
  v.addEventListener('transfer', this._didClickNext, this);
  v.addEventListener('back', this._didClickBack, this);

  superConstructor.prototype.start.call(this);
};

prototype._didRenderView = function(e) {
  var v = this._view;
  var wizard = this._wizard;
  var targets;
  var copy_count;

  if (!!!wizard) {
    throw new Error('not pushed into wizard stack');
  }
  targets = wizard.getRegistryEntry('targetItems');
  if (targets.length === 1) {
    copy_count = targets[0].copyCount;
    if (copy_count === 1) {
      v.setMoveOneItemView();
    } else {
      v.setMoveSameItemView(copy_count);
    }
  } else {
    v.setMoveItemView();
  }
};

prototype._didClickNext = function(e) {
  var w = this._wizard;
  var vc;

  vc = new ConfirmationWizardPageController();
  w.pushViewController(vc);
};

prototype._didClickBack = function(e) {
  var vc;

  if (!!this._wizard) {
    vc = this._wizard.popViewController();
    vc.destroy();
  }
};

}());
