/**
 * @module ctt
 * @submodule wizard-page-view
 */
(function() {
var Event = dixim.event.Event;
var ModalDialogView = dixim.ctt.ModalDialogView;
var $ = dixim.ctt.jQuery;

var WizardPageView;
var prototype;
var superConstructor;

var TEMPLATE_CONTENT_BOX = '<div class="ctt-wizard-page-view-wrapper" />';
var TEMPLATE_BODY_CONTENT = '<div class="ctt-wizard-page-view" />';

/**
 * @class WizardPageView
 * @extends ModalDialogView
 * @constructor
 * @param {Object} configs
 */
WizardPageView = function(configs) {
  ModalDialogView.call(this, configs);
};
dixim.inherit(WizardPageView, ModalDialogView);
dixim.ctt.WizardPageView = WizardPageView;
prototype = WizardPageView.prototype;
superConstructor = WizardPageView.superConstructor;

/**
 * Triggered when the page has been cancelled.
 *
 * @event cancel
 */
var CANCEL = 'cancel';

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
  configs  = configs || {};

  configs.contentBox = configs.contentBox || TEMPLATE_CONTENT_BOX;
  configs.bodyContent = configs.bodyContent || TEMPLATE_BODY_CONTENT;

  superConstructor.prototype._initialize.call(this, configs);
};

prototype._didTitlebarCloseButtonClick = function(e) {
  e.preventDefault();
  this.dispatchEvent(new Event(CANCEL));
};

}());