/**
 * @module dixim
 * @submodule contents
 */
dixim.namespace('dixim.contents');

/**
 * @module contents
 * @submodule deletion-dialog-view
 */

(function() {
var DeletionDialogView;
var prototype;
var superConstructor;
var _ = dixim.ctt.ResourceBundle.get;
var DeletionModalDialogView = dixim.common.DeletionModalDialogView;
var Enum = dixim.ctt.util.Enum;

/**
 * @class DeletionDialogView
 * @constructor
 * @param {Object} configs
 */
DeletionDialogView = function(configs) {
    DeletionModalDialogView.call(this, configs);
};

dixim.inherit(DeletionDialogView, DeletionModalDialogView);
dixim.contents.DeletionDialogView = DeletionDialogView;
prototype = DeletionDialogView.prototype;
superConstructor = DeletionDialogView.superConstructor;

var Mode = Enum.fetch('DELETION');

/**
 * @method _initialize
 * @protected
 * @param {Object} configs
 */
prototype._initialize = function(configs) {
    var contents = configs.contents || [];
    var mode = configs.mode || Mode.CONTENTS;

    configs = configs || {};

    configs.id = configs.id || '';
    configs.id = [configs.id, 'deletion-dialog-'].join('');

    switch(mode) {
        case Mode.CONTENTS:
            configs.title = _('contents_operation_menu_delete');
            configs.description = _('contents_deletion_dialog_description', contents.length);
            configs.nameKey = 'title';
            break;
        case Mode.DMS:
            configs.title = _('contents_transfer_wizard_deletion_title');
            configs.description = _('contents_transfer_wizard_deletion_description', contents.length);
            configs.nameKey = 'friendlyName';
            break;
        case Mode.LOG:
            configs.title = _('contents_transfer_reservation_dialog_delete_title');
            configs.description = _('contents_transfer_reservation_dialog_delete_description', contents.length);
            configs.nameKey = 'title';
            break;
    }

    configs.buttonText = _('dialog_delete');

    superConstructor.prototype._initialize.call(this, configs);
};

}());
